//
//  RGraphicsDeviceDelegateProxy.m
//  R
//
//  Created by Byron Ellis on 1/19/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "RGraphicsDeviceDelegateProxy.h"

#define DELEGATE_CALL_VOID \
	if([delegate respondsToSelector:_cmd]) { \
		IMP method = [delegate methodForSelector:_cmd];\
		method(delegate,_cmd,aDevice); \
		return;	 \
	}
#define DELEGATE_CALL(RET) \
	if([delegate respondsToSelector:_cmd]) { \
		IMP method = [delegate methodForSelector:_cmd];\
		return (RET)method(delegate,_cmd,aDevice); \
	}


@implementation RGraphicsDeviceDelegateProxy
+ (id)proxyWithDelegate:(id)aDelegate {
	return [[[self alloc] initWithDelegate:aDelegate] autorelease];
}
- (id)initWithDelegate:(id)aDelegate {
	if(nil == [super init]) return nil;
	delegate = aDelegate;
	return self;
}

- (void)graphicsDeviceWillDraw:(id)aDevice {
	DELEGATE_CALL_VOID;
}
- (void)graphicsDeviceDidDraw:(id)aDevice {
	DELEGATE_CALL_VOID;
}

- (void)graphicsDeviceNewPage:(id)aDevice {
	DELEGATE_CALL_VOID;
}

- (void)graphicsDeviceClose:(id)aDevice {
	DELEGATE_CALL_VOID;
}

- (BOOL)graphicsDeviceCanAcceptMouseEvents:(id)aDevice {
	DELEGATE_CALL(BOOL);
	return NO;
}

- (BOOL)graphicsDeviceCanResize:(id)aDevice {
	DELEGATE_CALL(BOOL);
	return NO;
}
- (BOOL)graphicsDeviceCanLocate:(id)aDevice {
	DELEGATE_CALL(BOOL);
	return NO;
}


- (NSSize)graphicsDeviceSize:(id)aDevice {
	if([delegate respondsToSelector: _cmd])
		return [delegate graphicsDeviceSize:aDevice];
	return NSMakeSize(0,0);
}

- (void)graphicsDeviceWillLocate:(id)aDevice {
	DELEGATE_CALL_VOID;
}
- (void)graphicsDeviceDidLocate:(id)aDevice {
	DELEGATE_CALL_VOID;
}
- (void)graphicsDevice:(id)aDevice showCoords:(NSPoint)rPoint atPoint:(NSPoint)aPoint {
	if([delegate respondsToSelector:_cmd]) { 
		IMP method = [delegate methodForSelector:_cmd];
		method(delegate,_cmd,aDevice,rPoint,aPoint); 
		return;	 
	}
}


@end
